# Method statements.list

- [HTTP request](https://developers.google.com/digital-asset-links/reference/rest/v1/statements/list#body.HTTP_TEMPLATE)
- [Query parameters](https://developers.google.com/digital-asset-links/reference/rest/v1/statements/list#body.QUERY_PARAMETERS)
- [Request body](https://developers.google.com/digital-asset-links/reference/rest/v1/statements/list#body.request_body)
- [Response body](https://developers.google.com/digital-asset-links/reference/rest/v1/statements/list#body.response_body)
  - [JSON representation](https://developers.google.com/digital-asset-links/reference/rest/v1/statements/list#body.ListResponse.SCHEMA_REPRESENTATION)
- [Statement](https://developers.google.com/digital-asset-links/reference/rest/v1/statements/list#Statement)
  - [JSON representation](https://developers.google.com/digital-asset-links/reference/rest/v1/statements/list#Statement.SCHEMA_REPRESENTATION)
- [Try it!](https://developers.google.com/digital-asset-links/reference/rest/v1/statements/list#try-it)

Retrieves a list of all statements from a given source that match the specified target and statement string.

The API guarantees that all statements with secure source assets, such as HTTPS websites or Android apps, have been made in a secure way by the owner of those assets, as described in the [Digital Asset Links technical design specification](https://github.com/google/digitalassetlinks/blob/master/well-known/details.md). Specifically, you should consider that for insecure websites (that is, where the URL starts with `http://` instead of `https://`), this guarantee cannot be made.

The `List` command is most useful in cases where the API client wants to know all the ways in which two assets are related, or enumerate all the relationships from a particular source asset. Example: a feature that helps users navigate to related items. When a mobile app is running on a device, the feature would make it easy to navigate to the corresponding web site or Google+ profile.

### HTTP request

`GET https://digitalassetlinks.googleapis.com/v1/statements:list`

### Query parameters

| Parameter name | Type | Description |
|---|---|---|
| `source` | ``object(`https://developers.google.com/digital-asset-links/reference/rest/v1/Asset`)`` | The source hosting the statement list. This is used to direct the `List()` request to the right source. REQUIRED |
| `relation` | `string` | Use only associations that match the specified relation. See the [`Statement`](https://developers.google.com/digital-asset-links/reference/rest/v1/statements/list#Statement) message for a detailed definition of relation strings. For a query to match a statement, one of the following must be true: - both the query's and the statement's relation strings match exactly, or - the query's relation string is empty or missing. Example: A query with relation `delegate_permission/common.handle_all_urls` matches an asset link with relation `delegate_permission/common.handle_all_urls`. |

### Request body

The request body must be empty.

### Response body

If successful, the response body contains data with the following structure:
Response message for the List call.

| JSON representation |
|---|
| ``` { "statements": [ { object(`https://developers.google.com/digital-asset-links/reference/rest/v1/statements/list#Statement`) } ], "maxAge": string, "debugString": string, } ``` |

| Field name | Type | Description |
|---|---|---|
| `statements[]` | ``object(`https://developers.google.com/digital-asset-links/reference/rest/v1/statements/list#Statement`)`` | A list of all the matching statements that have been found. |
| `maxAge` | `string` | From serving time, how much longer the response should be considered valid barring further updates. REQUIRED A duration in seconds with up to nine fractional digits, terminated by '`s`'. Example: `"3.5s"`. |
| `debugString` | `string` | Human-readable message containing information intended to help end users understand, reproduce and debug the result. The message will be in English and we are currently not planning to offer any translations. Please note that no guarantees are made about the contents or format of this string. Any aspect of it may be subject to change without notice. You should not attempt to programmatically parse this data. If you feel that you need to do this because the information you need is not otherwise exposed by the API, please contact us first. |

## Statement

Describes a reliable statement that has been made about the relationship between a source asset and a target asset.

Statements are always made by the source asset, either directly or by delegating to a statement list that is stored elsewhere.

For more detailed definitions of statements and assets, please refer to our [API documentation landing page](https://developers.google.com/digital-asset-links/v1/getting-started).

| JSON representation |
|---|
| ``` { "source": { object(`https://developers.google.com/digital-asset-links/reference/rest/v1/Asset`) }, "relation": string, "target": { object(`https://developers.google.com/digital-asset-links/reference/rest/v1/Asset`) }, } ``` |

| Field name | Type | Description |
|---|---|---|
| `source` | ``object(`https://developers.google.com/digital-asset-links/reference/rest/v1/Asset`)`` | Every statement has a source asset. REQUIRED |
| `relation` | `string` | The relation identifies the use of the statement as intended by the source asset's owner (that is, the person or entity who issued the statement). Every complete statement has a relation. We identify relations with strings of the format `<kind>/<detail>`, where `<kind>` must be one of a set of pre-defined purpose categories, and `<detail>` is a free-form lowercase alphanumeric string that describes the specific use case of the statement. Refer to [our API documentation](https://developers.google.com/digital-asset-links/v1/relation-strings) for the current list of supported relations. Example: `delegate_permission/common.handle_all_urls` REQUIRED |
| `target` | ``object(`https://developers.google.com/digital-asset-links/reference/rest/v1/Asset`)`` | Every statement has a target asset. REQUIRED |

## Try it!

Use the [APIs Explorer](https://developers.google.com/apis-explorer/?discovery_url=/digital-asset-links/v1/discoverydocument.json#p/digitalassetlinks/v1/digitalassetlinks.statements.list?relation=delegate_permission%252Fcommon.handle_all_urls&source.web.site=https%253A%252F%252Fexample.digitalassetlinks.org&_h=1&) to call this method on live data and see the response.